--[[
aUF_RangeCheck SK v2.00
Author: Kothnok & Shadowwolf of Alexstrasza
Based on work done by miles.
Last Changed: 2008.05.25
Changes: See changelog.html
]]

aUFR_NotVisibleAlpha = 0.3; --this only controls if the game has loaded the unit object, not LOS. I see no reason to make it seperate from NotInRangeAlpha at this time
aUFR_NotInRangeAlpha = 0.6;
aUFR_aid_healbuff = "";
aUFR_aid_offense = "";

aUF_RangeCheck_Config = {};
aUF_RangeCheck = {};
local aUFR = aUF_RangeCheck;

-- Get a reference to aUF by global (old style) or LibStub (Ace3)
local aUF_global = aUF;
local aUF_3 = nil;
if (LibStub("AceAddon-3.0", true)) then
	aUF_3 = LibStub("AceAddon-3.0"):GetAddon("ag_UnitFrames", true)
end
local aUF = aUF_global or aUF_3 or nil;

aUFR.frame = CreateFrame("Frame", "aUF_RangeCheck_Frame", UIParent);
--using a pre-defined table size for the queue so that memory allocation/deallocation is minimized (speed optimization)
aUFR.queue = {nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil}; --enough for 25man raid +target & target of target, will grow if need more
aUFR.queuesize = 0;

function aUFR.FillQueue()
	aUFR.queuesize = 0;
	if (aUF and aUF.unitid) then
		for k, v in pairs(aUF.unitid) do
			for obj, used in pairs(v) do
				if used and (obj.unit ~= "player") then
					aUFR.queuesize = aUFR.queuesize + 1;
					aUFR.queue[aUFR.queuesize] = obj;
				end
			end
		end
	end
end

function aUFR.TargetInRange(aUnit)
	if UnitIsFriend("player",aUnit) then
		aUFR_aid = aUFR_aid_healbuff;
	else
		aUFR_aid = aUFR_aid_offense;
	end
	if (aUFR_aid ~= "") then
		return (not (IsSpellInRange(aUFR_aid,aUnit)==0) ) --0=not in range, 1=in range, nil=invalid target
	else
		return CheckInteractDistance(aUnit,4)
	end
end

function aUFR.UpdateRange(agUnitFrame)
	if (not UnitIsVisible(agUnitFrame.unit)) then --ie. the unit object isn't loaded in game yet, no need to check range
		agUnitFrame.frame:SetAlpha(aUFR_NotInRangeAlpha);
	elseif (aUFR.TargetInRange(agUnitFrame.unit)) then
		agUnitFrame.frame:SetAlpha(1);
	else
		agUnitFrame.frame:SetAlpha(aUFR_NotInRangeAlpha);
	end
end

function aUFR.OnUpdate(self)
	if (aUFR.queuesize<1) then
		aUFR.FillQueue();
	end
	--now check to see if queue was filled and if so, check the range
	if (aUFR.queuesize>0) then
		aUFR.UpdateRange(aUFR.queue[aUFR.queuesize]);
		aUFR.queuesize = aUFR.queuesize - 1;
	end
end

function aUFR.OnEvent(self, event, arg1) 
	if (event == "PLAYER_TARGET_CHANGED") then
		for k,v in pairs(aUF.unitid.target) do
			aUFR.UpdateRange(k);
		end
		-- targettarget unit is not updated yet!
		--[[
		for k,v in pairs(aUF.unitid.targettarget) do
			aUFR.UpdateRange(k);
		end
		]]
	elseif (event == "VARIABLES_LOADED") then
		--aUF_RangeCheck_Config_SliderNotVisibleAlpha:SetValue(aUFR_NotVisibleAlpha);
		aUF_RangeCheck_Config_SliderNotInRangeAlpha:SetValue(aUFR_NotInRangeAlpha);
		aUF_RangeCheck_Config_EditBoxHealBuffName:SetText(aUFR_aid_healbuff);
		aUF_RangeCheck_Config_EditBoxOffenseName:SetText(aUFR_aid_offense);
	else
		ChatFrame4:AddMessage(event .. ": " .. tostring(arg1));
	end
end

-- ===== CONFIG FUNCTIONS =====
function aUF_RangeCheck_Config:OnLoad(self)
	self.name = sAddonName; 
	InterfaceOptions_AddCategory(self); 
	aUF_RangeCheck_ConfigTitle:SetText(sAddonName);
	aUF_RangeCheck_ConfigSubTitle:SetText("|cFFFFFFFF"..sAddonVersion.." by Kothnok & Shadowwolf".."|r");
	--aUF_RangeCheck_ConfigNotVisibleAlpha:SetText(aUFRtxt_LabelUnitNotInGameAlpha..":\n"..aUFRtxt_Default..": |cFF4DBD330.3|r");
	aUF_RangeCheck_ConfigNotInRangeAlpha:SetText(aUFRtxt_LabelOutOfRangeAlpha..":\n"..aUFRtxt_Default..": |cFF4DBD330.6|r");
	aUF_RangeCheck_ConfigHealBuffName:SetText(aUFRtxt_LabelHealBuffName..":");
	aUF_RangeCheck_ConfigOffenseName:SetText(aUFRtxt_LabelOffenseName..":");
end

function aUF_RangeCheck_Config:OnShow(self)
	--aUF_RangeCheck_Config_SliderNotVisibleAlpha:SetValue(aUFR_NotVisibleAlpha);
	aUF_RangeCheck_Config_SliderNotInRangeAlpha:SetValue(aUFR_NotInRangeAlpha);
	aUF_RangeCheck_Config_EditBoxHealBuffName:SetText(aUFR_aid_healbuff);
	aUF_RangeCheck_Config_EditBoxOffenseName:SetText(aUFR_aid_offense);
	aUF_RangeCheck_Config_EditBoxHealBuffName:SetCursorPosition(0); --needed, else text is scrolled left and invisible
	aUF_RangeCheck_Config_EditBoxOffenseName:SetCursorPosition(0); --needed, else text is scrolled left and invisible
end

function aUF_RangeCheck_Config:OnHide(self)
	aUFR_aid_healbuff = aUF_RangeCheck_Config_EditBoxHealBuffName:GetText();
	aUFR_aid_offense = aUF_RangeCheck_Config_EditBoxOffenseName:GetText();
end

function aUF_RangeCheck_Config:SliderNotVisibleAlphaChange(theSlider)
	aUFR_NotVisibleAlpha = theSlider:GetValue();
	aUFR.OnUpdate();
	getglobal(theSlider:GetName() .. "Text"):SetText(string.format("%.1f",theSlider:GetValue()));
end

function aUF_RangeCheck_Config:SliderNotInRangeAlphaChange(theSlider)
	aUFR_NotInRangeAlpha = theSlider:GetValue();
	aUFR.OnUpdate();
	getglobal(theSlider:GetName() .. "Text"):SetText(string.format("%.1f",theSlider:GetValue()));
end

function aUF_RangeCheck_Config:SliderNotInRangeAlphaTooltip(sender)
	GameTooltip:SetOwner(sender, "ANCHOR_RIGHT");
	GameTooltip:SetText(aUFRtt_OutOfRangeAlpha, nil, nil, nil, nil, 1);
end

function aUF_RangeCheck_Config:EditBoxHealBuffNameTooltip(sender)
	GameTooltip:SetOwner(sender, "ANCHOR_RIGHT");
	GameTooltip:SetText(aUFRtt_HealBuffSpell, nil, nil, nil, nil, 1);
end

function aUF_RangeCheck_Config:EditBoxOffenseNameTooltip(sender)
	GameTooltip:SetOwner(sender, "ANCHOR_RIGHT");
	GameTooltip:SetText(aUFRtt_OffenseSpell, nil, nil, nil, nil, 1);
end

if (aUF and aUFR) then
	aUFR_Localize(GetLocale());
	aUFR.frame:SetScript("OnUpdate", aUFR.OnUpdate);
	aUFR.frame:SetScript("OnEvent", aUFR.OnEvent);
	aUFR.frame:RegisterEvent("ADDON_LOADED");
	aUFR.frame:RegisterEvent("PLAYER_TARGET_CHANGED");
	aUFR.frame:RegisterEvent("VARIABLES_LOADED");
else
	ChatFrame1:AddMessage(sAddonName..": "..aUFRtxt_NotInitialized);
end